# =====================================================================
# envtoxml.awk: shell front-end to the envtoxml() AWK function.
#
# Copyright (c) 2002,2003 Carlo Strozzi
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#
# =====================================================================
# $Id: envtoxml.awk,v 1.2 2004/08/08 21:15:37 carlo Exp $

BEGIN {

  # Set default args before calling envtoxml(). I use the same
  # names here for clarity, but it is not necessary, of course,
  # as everything is localised by the function.

  if (tpl == "") tpl = "/dev/null"
  if (tbl !~ /^\//) tbl = ""		# Accept only full-path spec.
  if (froot == "") froot = ENVIRON["CSA_ROOT"] "/xml/"
  if (trim != 1) trim = 0
  if (tago == "") tago = "$["
  if (tagc == "") tagc = "]"
  if (tago == tagc) exit(1)	# start- and end-tags must be different
  if (ofile == "") ofile = _STDOUT

  if ((rc = _envtoxml(tpl,froot,eval,tbl,trim,tago,tagc,ofile))) exit(rc)
}

# EOF
